--- old/usr/src/lib/libc/port/gen/getlogin.c	Sat Apr 20 14:17:50 2013
+++ new/usr/src/lib/libc/port/gen/getlogin.c	Sat Apr 20 14:17:50 2013
@@ -20,6 +20,8 @@
  */
 
 /*
+ * Copyright (c) 2013 Gary Mills
+ *
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
@@ -27,8 +29,6 @@
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved  	*/
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #pragma weak _getlogin = getlogin
 #pragma weak _getlogin_r = getlogin_r
 
@@ -48,9 +48,8 @@
 #include "tsd.h"
 
 /*
- * XXX - _POSIX_LOGIN_NAME_MAX limits the length of a login name.  The utmpx
- * interface provides for a 32 character login name, but for the sake of
- * compatibility, we are still using the old utmp-imposed limit.
+ * Use the full length of a login name, from LOGIN_NAME_MAX .
+ * The utmpx interface provides for a 32 character login name.
  */
 
 /*
@@ -64,6 +63,7 @@
 	off64_t		me;
 	struct futmpx	ubuf;
 
+	/* Required minimum */
 	if (namelen < _POSIX_LOGIN_NAME_MAX) {
 		errno = ERANGE;
 		return (NULL);
@@ -81,9 +81,15 @@
 	(void) close(uf);
 	if (ubuf.ut_user[0] == '\0')
 		return (NULL);
+
+	/* Insufficient buffer size */
+	if (namelen < strnlen(&ubuf.ut_user[0], LOGIN_NAME_MAX - 1)) {
+		errno = ERANGE;
+		return (NULL);
+	}
 	(void) strncpy(&answer[0], &ubuf.ut_user[0],
-	    _POSIX_LOGIN_NAME_MAX - 1);
-	answer[_POSIX_LOGIN_NAME_MAX - 1] = '\0';
+	    LOGIN_NAME_MAX - 1);
+	answer[LOGIN_NAME_MAX - 1] = '\0';
 	return (&answer[0]);
 }
 
@@ -111,9 +117,9 @@
 char *
 getlogin(void)
 {
-	char *answer = tsdalloc(_T_LOGIN, _POSIX_LOGIN_NAME_MAX, NULL);
+	char *answer = tsdalloc(_T_LOGIN, LOGIN_NAME_MAX, NULL);
 
 	if (answer == NULL)
 		return (NULL);
-	return (getlogin_r(answer, _POSIX_LOGIN_NAME_MAX));
+	return (getlogin_r(answer, LOGIN_NAME_MAX));
 }
